'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _wrapDisplayName = require('recompose/wrapDisplayName');

var _wrapDisplayName2 = _interopRequireDefault(_wrapDisplayName);

var _reduxSubspace = require('redux-subspace');

var _SubspaceProvider = require('./SubspaceProvider');

var _SubspaceProvider2 = _interopRequireDefault(_SubspaceProvider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var subspaced = function subspaced(mapState, namespace) {

    var subspaceDecorator = (0, _reduxSubspace.subspace)(mapState, namespace);

    return function (WrappedComponent) {

        var SubspacedComponent = function SubspacedComponent(props) {
            return _react2.default.createElement(
                _SubspaceProvider2.default,
                { subspaceDecorator: subspaceDecorator },
                _react2.default.createElement(WrappedComponent, props)
            );
        };

        (0, _hoistNonReactStatics2.default)(SubspacedComponent, WrappedComponent);

        SubspacedComponent.displayName = (0, _wrapDisplayName2.default)(WrappedComponent, 'Subspaced');

        return SubspacedComponent;
    };
}; /**
    * Copyright 2017, IOOF Holdings Limited.
    * All rights reserved.
    *
    * This source code is licensed under the BSD-style license found in the
    * LICENSE file in the root directory of this source tree.
    */

exports.default = subspaced;